function [res, isSuccess] = querystoredprocedure(obj, stpName, arrParam, cmdType, nTimeout) 
% adoCmd Generic Routine to run a SQL Server stored procedure.

res = {};

adCmdStoredProc = 4;

adVarChar = 200;
adInteger = 3;
adParamInput = 1;
adParamOutput = 3;
adParamReturnValue = 4;

if ~exist('stpName', 'var') return; end 

if ~exist('cmdType', 'var') cmdType = adCmdStoredProc; end 
if ~exist('nTimeout', 'var') nTimeout = 0; end 

adoCmd = actxserver('ADODB.Command');
set(adoCmd, 'CommandType',      cmdType);
set(adoCmd, 'CommandTimeout',   nTimeout);
set(adoCmd, 'CommandText',      stpName);
set(adoCmd, 'ActiveConnection', obj.conn);

if ~isempty(arrParam)
    param = actxserver('ADODB.Parameter');
    
    for i = 1:length(arrParam)
        param = adoCmd.CreateParameter;
        set(param, 'Name',      arrParam(i).stpParamName);
        
        % set parameter varType
        switch lower(arrParam(i).varType)
          case {'int', 'integer'}
            varType = adInteger;
          case {'char', 'string'}
            varType = adVarChar;
          otherwise
            disp('Unknown parameter var type. Parameter var type should be either int or char');
            return;
        end
        set(param, 'Type',  varType);
        
        % set parameter direction
        switch lower(arrParam(i).paramType)
          case {'in', 'input'}
            dir = adParamInput;
          case {'out', 'output'}
            dir = adParamOutput;
          case {'return', 'ret', 'returnvalue'}
            dir = adParamReturnValue;
          otherwise
            disp('Unknown parameter direction. Parameter direction should be either in, out or return');
            return;
        end
        set(param, 'Direction', dir);
        
        % set the size of the parameter
        set(param, 'Size',      arrParam(i).size);

        % set the value of the parameter
        set(param, 'Value',     arrParam(i).value);
        
        adoCmd.Parameters.Append(param);
    end
end

isSuccess = 1;