function setconn(obj, connStr, timeout)
%ADODB/SETCONN set up the connection string of adodb object
%
% Copyright: zhang@zhiqiang.org

%% if the connection string is not changed, do nothing and return
if ischar(connStr) && strcmp(connStr, obj.connStr)
    return;
end

if ischar(connStr), obj.connStr = connStr; end

%% if the connStr uses abbraviations, convert it to real value
if ischar(connStr) && length(connStr) <= 10 ...
        && obj.savedConnectionStrings.isKey(lower(connStr))
    connStr = obj.savedConnectionStrings(lower(connStr));
end

%% when connStr is a cell or a struct, we need to convert it to
% a string using method connstr
if iscell(connStr) || isstruct(connStr)
    connStr = obj.connstr(connStr);
end


%% config the adodb connection object
obj.conn.Open(connStr);

% Specify connection timeout if provided
if nargin >= 3
    set(obj.conn,'CommandTimeout',timeout);
else
    set(obj.conn,'CommandTimeout',60);    %default
end
